=== debian/changelog ===
alljoyn-thin-client-1509 (15.09a-2ubuntu1) artful; urgency=medium

  * debian/patches/link-pthread.patch: Add -pthread to LINKFLAGS to fix FTBFS.

 -- Logan Rosen <logan@ubuntu.com>  Tue, 20 Jun 2017 22:36:43 -0700

alljoyn-thin-client-1509 (15.09a-2) unstable; urgency=medium

  * move package to debian-iot-maintainer
  * add VCS URLs

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 26 Dec 2016 11:28:32 +0100

alljoyn-thin-client-1509 (15.09a-1) unstable; urgency=medium

  * Initial release (Closes: #828129)

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 25 Jun 2016 11:28:32 +0200
