=== debian/watch ===
version=3
opts="dversionmangle=s/core/alljoyn-thin-client/" \
https://git.allseenalliance.org/cgit/core/ajtcl.git/ /cgit/core/ajtcl.git/snapshot/ajtcl-(15\.09.*)\.tar\.gz
